    using System;

	public enum Month {
							Jan, Feb, Mar, Apr, May, Jun,
							Jul, Aug, Sep, Oct, Nov, Dec
				      }

	public enum Category {
							Food, Home, Jeans, Fun
					     }
    /// <summary>
    ///    Summary description for Budget.
    /// </summary>
    public class Budget
    {
		static decimal increment = 0.1m;

		decimal[,] myBudget = new decimal[4, 12];

		public void Initialize(decimal[] initVals)
		{
			for (Category c=Category.Food; c <= Category.Fun; c++)
			{
				for (Month m=Month.Jan; m <= Month.Dec; m++)
				{
					myBudget[(int)c, (int)m] = initVals[(int)m];
				}
			}
		}
		public void Initialize(decimal initVal)
		{
			for (Category c=Category.Food; c <= Category.Fun; c++)
			{
				for (Month m=Month.Jan; m <= Month.Dec; m++)
				{
					myBudget[(int)c, (int)m] = initVal;
				}
			}
		}

		public decimal this[int cat, int mon]
		{
			get
			{
				return myBudget[cat, mon];
			}
			set 
			{
				myBudget[cat, mon] = value;
			}
		}
		
		public decimal this[Category cat, Month mon]
		{
			get
			{
				return myBudget[(int)cat, (int)mon];
			}
			set 
			{
				myBudget[(int)cat, (int)mon] = value;
			}
		}

		public decimal this[string cat, string mon]
		{
			get
			{
				return myBudget[
					(int)Enum.FromString(typeof(Category), cat, true), 
					(int)Enum.FromString(typeof(Month),    mon, true)
							   ];
			}
			set 
			{
				myBudget[
					(int)Enum.FromString(typeof(Category), cat, true), 
					(int)Enum.FromString(typeof(Month),    mon, true)
						] = value;
			}
		}

		public static Budget operator+(Budget oldBud, decimal amount)
		{
			Budget newBud = new Budget();

			for (Category c=Category.Food; c <= Category.Fun; c++)
			{
				for (Month m=Month.Jan; m <= Month.Dec; m++)
				{
					newBud[c, m] = oldBud[c, m] + amount;
				}
			}

			return newBud;
		}

		public static Budget operator++(Budget oldBud)
		{
			Budget newBud = new Budget();

			for (Category c=Category.Food; c <= Category.Fun; c++)
			{
				for (Month m=Month.Jan; m <= Month.Dec; m++)
				{
					newBud[c, m] = oldBud[c, m] + Increment;
				}
			}

			return newBud;
		}

		public static decimal Increment 
		{
			get
			{
				return increment;
			}
			set 
			{
				increment = value;
			}
		}

		public void PrintBudget() 
		{
			Console.WriteLine("\n\nMY BUD - Annual Budget\n");
			
			Console.Write("     ");
			for (Month m=Month.Jan; m <= Month.Dec; m++)
			{
				Console.Write("{0,6}", Enum.GetName(typeof(Month), m));
			}

			Console.WriteLine();
			for (Category c=Category.Food; c <= Category.Fun; c++)
			{
				Console.Write("\n{0,-7}", Enum.GetName(typeof(Category), c));
				for (Month m=Month.Jan; m <= Month.Dec; m++)
				{
					Console.Write("{0,4}  ", myBudget[(int)c, (int)m]);
				}
			}			
		}

		public void someMethod(string myValue)
		{
			Console.WriteLine("In someMethod(string).");
		}
		public void someMethod(uint myValue)
		{
			Console.WriteLine("In someMethod(uint).");
		}
		public void someMethod(long myValue)
		{
			Console.WriteLine("In someMethod(long).");
		}
    }
