using System;
using System.IO;

public class TooManyItemsException : CoreException
{
    public TooManyItemsException() : base(@"

**TooManyItemsException**  You added too many items
to this container.  Try specifying a smaller number
or increasing the container size.

")
    {
    }
}

public class ExceptionTester
{
    public static int Main(string[] args)
    {
        ExceptionTester myExceptionMaker = new ExceptionTester();

        try
        {
            myExceptionMaker.GenerateException(5);
        }
        catch (Exception e)
        {
            Console.WriteLine("\nMessage: {0}", e.Message);
        }
        finally
        {
            Console.WriteLine("Finally from Main()");
        }

        return 0;
    }

    void GenerateException(int iterations)
    {
        int mySize = 3;
        byte[] myStream = new byte[mySize];
        StreamWriter sw = new StreamWriter("exceptions.txt");

        try
        {
            if (iterations > myStream.Length)
            {
                throw new TooManyItemsException();
            }

            for (byte b=0; b < iterations; b++)
            {
                sw.WriteLine("Byte {0}: {1}", b+1, b);
                myStream[b] = b;
            }
        }
        finally
        {
            Console.WriteLine("Finally from GenerateException.");
            sw.WriteLine("Close");
            sw.Close();
        }
    }
}
