using System;

public delegate void MenuHandler(object sender, EventArgs e);

public class MenuItem
{
	int    numberOfEvents;
	string text;

	private MenuHandler mh = null;

	public event MenuHandler MenuSelection
	{
		add 
		{
			mh += value;
			numberOfEvents++;
		}
		remove 
		{
			mh -= value;
			numberOfEvents--;
		}
	}
	
	public MenuItem(string text)
	{
		this.text = text;
		numberOfEvents = 0;
	}

	public void Fire() 
	{
		OnMenuSelection();
	}

	protected void OnMenuSelection()
	{
		if (mh != null)
		{
			mh(this, null);
		}
	}

	public string Text
	{
		get 
		{
			return text;
		}
		set 
		{
			text = value;
		}
	}
	public int NumberOfEvents
	{
		get 
		{
			return numberOfEvents;
		}
	}
}

