using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;

public class DeleteForm : Form
{
    SiteManager citeMgr;

    private Container components;
    private Panel     separator;
    private Button    okButton;
    private Button    cancelButton;
    private Button    deleteButton;
    private ListBox   deleteListbox;

    public DeleteForm(SiteManager citeMgr)
    {
        InitializeComponent();

        this.citeMgr = citeMgr;

        for (int i=0;i < this.citeMgr.Count; i++)
        {
            deleteListbox.Items.Insert(i, this.citeMgr[i].ToString());
        }
    }

    public override void Dispose()
    {
        base.Dispose();
        components.Dispose();
    }

    private void InitializeComponent()
    {
        components    = new Container();
        okButton      = new Button();
        cancelButton  = new Button();
        deleteButton  = new Button();
        deleteListbox = new ListBox();
        separator     = new Panel();

        okButton.Text         = "OK";
        okButton.Location     = new Point(40, 216);
        okButton.Size         = new Size(75, 23);
        okButton.DialogResult = DialogResult.OK;
        okButton.TabIndex     = 2;

        cancelButton.Text     = "Cancel";
        cancelButton.Location = new Point (176, 216);
        cancelButton.Size     = new Size (75, 23);
        cancelButton.TabIndex = 3;

        deleteButton.Text     = "Delete";
        deleteButton.Click   += new EventHandler (deleteButton_Click);
        deleteButton.Location = new Point(104, 152);
        deleteButton.Size     = new Size(75, 23);
        deleteButton.TabIndex = 1;

        deleteListbox.Location = new Point(8, 8);
        deleteListbox.Size     = new Size(280, 134);
        deleteListbox.TabIndex = 0;

        separator.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
        separator.Location    = new Point(8, 184);
        separator.Size        = new Size(280, 4);
        separator.TabIndex    = 4;

        Text       = "Delete Form";
        ClientSize = new Size (296, 261);

        Controls.Add(separator);
        Controls.Add(cancelButton);
        Controls.Add(okButton);
        Controls.Add(deleteButton);
        Controls.Add(deleteListbox);
    }

    protected void deleteButton_Click (object sender, System.EventArgs e)
    {
        citeMgr.DeleteSite(deleteListbox.SelectedIndex);
        deleteListbox.Items.Remove(deleteListbox.SelectedIndex);
        deleteListbox.Invalidate();
    }
}
