using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;

public class ModifyForm : Form
{
    SiteManager citeMgr;

    private Container components;
    private Label     selectionLabel;
    private ComboBox  selectionCombobox;
    private Button    changeButton;
    private Label     sitenameLabel;
    private Label     addressLabel;
    private Label     descriptionLabel;
    private TextBox   sitenameTextbox;
    private TextBox   addressTextbox;
    private TextBox   descriptionTextbox;
    private GroupBox  groupBox;
    private Button    okButton;
    private Button    cancelButton;

    public ModifyForm(SiteManager citeMgr)
    {
        InitializeComponent();

        this.citeMgr = citeMgr;

        for (int i=0;i < this.citeMgr.Count; i++)
        {
            selectionCombobox.Items.Insert(i, this.citeMgr[i].ToString());
        }

        selectionCombobox.SelectedIndex = 0;
}

    public override void Dispose()
    {
        base.Dispose();
        components.Dispose();
    }

    private void InitializeComponent()
    {
        components         = new Container();
        selectionLabel     = new Label();
        selectionCombobox  = new ComboBox();
        changeButton       = new Button();
        sitenameLabel      = new Label();
        addressLabel       = new Label();
        descriptionLabel   = new Label();
        sitenameTextbox    = new TextBox();
        addressTextbox     = new TextBox();
        descriptionTextbox = new TextBox();
        groupBox          = new GroupBox();
        okButton           = new Button();
        cancelButton       = new Button();

        selectionLabel.Text      = "Select Cite:";
        selectionLabel.Location  = new Point(32, 24);
        selectionLabel.Size      = new Size(64, 21);
        selectionLabel.TextAlign = ContentAlignment.MiddleRight;
        selectionLabel.TabIndex  = 9;

        selectionCombobox.Text                  = "comboBox1";
        selectionCombobox.SelectedIndexChanged += new EventHandler(selectionCombobox_SelectedIndexChanged);
        selectionCombobox.Location              = new Point(104, 24);
        selectionCombobox.Size                  = new Size(232, 21);
        selectionCombobox.TabIndex              = 8;

        changeButton.Text     = "Change";
        changeButton.Click   += new EventHandler(changeButton_Click);
        changeButton.Location = new Point(368, 24);
        changeButton.Size     = new Size(75, 23);
        changeButton.TabIndex = 10;

        sitenameLabel.Text      = "Site Name:";
        sitenameLabel.Location  = new Point(32, 80);
        sitenameLabel.Size      = new Size(64, 20);
        sitenameLabel.TextAlign = ContentAlignment.MiddleRight;
        sitenameLabel.TabIndex  = 0;

        addressLabel.Text      = "Address:";
        addressLabel.Location  = new Point(32, 128);
        addressLabel.Size      = new Size(64, 20);
        addressLabel.TextAlign = ContentAlignment.MiddleRight;
        addressLabel.TabIndex  = 1;

        descriptionLabel.Text      = "Description:";
        descriptionLabel.Location  = new Point(32, 176);
        descriptionLabel.Size      = new Size(64, 20);
        descriptionLabel.TextAlign = ContentAlignment.MiddleRight;
        descriptionLabel.TabIndex  = 2;

        sitenameTextbox.Location = new Point(104, 80);
        sitenameTextbox.Size     = new Size(344, 20);
        sitenameTextbox.TabIndex = 5;
        addressTextbox.Location = new Point(104, 128);
        addressTextbox.Size     = new Size(344, 20);
        addressTextbox.TabIndex = 6;

        descriptionTextbox.Location = new Point(104, 176);
        descriptionTextbox.Size     = new Size(344, 20);
        descriptionTextbox.TabIndex = 7;

        groupBox.Text     = "Modified Data";
        groupBox.Location = new Point(16, 56);
        groupBox.Size     = new Size(456, 152);
        groupBox.TabStop  = false;
        groupBox.TabIndex = 11;

        okButton.Text              = "OK";
        okButton.Location          = new Point(128, 224);
        okButton.Size              = new Size(75, 23);
        okButton.DialogResult      = DialogResult.OK;
        okButton.TabIndex          = 3;

        cancelButton.Text         = "Cancel";
        cancelButton.Location     = new Point(272, 224);
        cancelButton.Size         = new Size(75, 23);
        cancelButton.DialogResult = DialogResult.Cancel;
        cancelButton.TabIndex     = 4;

        Text       = "Modify Form";
        ClientSize = new System.Drawing.Size (488, 261);

        Controls.Add(changeButton);
        Controls.Add(selectionLabel);
        Controls.Add(selectionCombobox);
        Controls.Add(descriptionTextbox);
        Controls.Add(addressTextbox);
        Controls.Add(sitenameTextbox);
        Controls.Add(cancelButton);
        Controls.Add(okButton);
        Controls.Add(descriptionLabel);
        Controls.Add(addressLabel);
        Controls.Add(sitenameLabel);
        Controls.Add(groupBox);
    }

    protected void changeButton_Click (object sender, System.EventArgs e)
    {
        citeMgr.DeleteSite(selectionCombobox.SelectedIndex);
        citeMgr.AddSite(sitenameTextbox.Text, addressTextbox.Text, descriptionTextbox.Text);
        selectionCombobox.Items[selectionCombobox.SelectedIndex] = citeMgr[selectionCombobox.SelectedIndex].ToString();
    }

    protected void selectionCombobox_SelectedIndexChanged (object sender, System.EventArgs e)
    {
        WebSites.WebSite cite = citeMgr[selectionCombobox.SelectedIndex];

        sitenameTextbox.Text    = cite.SiteName;
        addressTextbox.Text     = cite.URL;
        descriptionTextbox.Text = cite.Description;
    }
}
