using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;

public class ViewForm : Form
{
    private Container    components;
    private Button       cancelButton;
    private Button       okButton;
    private ColumnHeader nameColumnHeader;
    private ColumnHeader urlColumnHeader;
    private ColumnHeader descriptionColumnHeader;
    private ListView     viewListview;

    public ViewForm(SiteManager citeMgr)
    {
        string[] columns = new string[3];

        InitializeComponent();

        for (int i=0;i < citeMgr.Count; i++)
        {
            columns[0] = citeMgr[i].SiteName;
            columns[1] = citeMgr[i].URL;
            columns[2] = citeMgr[i].Description;

            ListViewItem list = new ListViewItem(columns);
            viewListview.Items.Add(list);
        }
    }

    public override void Dispose()
    {
        base.Dispose();
        components.Dispose();
    }

    private void InitializeComponent()
    {
        components              = new Container();
        okButton                = new Button();
        cancelButton            = new Button();
        nameColumnHeader        = new ColumnHeader();
        urlColumnHeader         = new ColumnHeader();
        descriptionColumnHeader = new ColumnHeader();
        viewListview            = new ListView();

        okButton.Text         = "OK";
        okButton.Location     = new Point(88, 224);
        okButton.Size         = new Size(75, 23);
        okButton.DialogResult = DialogResult.OK;
        okButton.TabIndex     = 1;

        nameColumnHeader.Text      = "Cite Name";
        nameColumnHeader.TextAlign = HorizontalAlignment.Left;
        nameColumnHeader.Width     = 87;

        urlColumnHeader.Text      = "Address";
        urlColumnHeader.TextAlign = HorizontalAlignment.Left;
        urlColumnHeader.Width     = 135;

        descriptionColumnHeader.Text      = "Description";
        descriptionColumnHeader.TextAlign = HorizontalAlignment.Left;
        descriptionColumnHeader.Width     = 255;

        cancelButton.Text         = "Cancel";
        cancelButton.Location     = new Point(232, 224);
        cancelButton.Size         = new Size(75, 23);
        cancelButton.DialogResult = DialogResult.Cancel;
        cancelButton.TabIndex     = 2;

        viewListview.Columns.AddRange(new ColumnHeader[3]
            {
                nameColumnHeader,
                urlColumnHeader,
                descriptionColumnHeader
            }
        );
        viewListview.Location           = new Point(8, 8);
        viewListview.Size               = new Size(368, 192);
        viewListview.Sorting            = SortOrder.Ascending;
        viewListview.View               = View.Details;
        viewListview.GridLines          = true;
        viewListview.TabIndex           = 0;

        Text       = "View Form";
        ClientSize = new System.Drawing.Size(384, 273);

        Controls.Add (okButton);
        Controls.Add (cancelButton);
        Controls.Add (viewListview);
    }
}
