using System;
using System.IO;
using System.Text;
using System.Collections;
using System.Reflection;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Soap;

[assembly: AssemblyVersion("1.0.0.0")]

[Serializable]
public class Serialized : ISerializable
{
	string permanent;
	string temporary;

	public Serialized()
	{
	}

	public Serialized(SerializationInfo serInfo, StreamingContext streamContext)
	{
		string assembly;
		string[] assemblyAttributes = new string[2];

		Console.WriteLine("Inside Serialization Constructor\n");

		permanent = serInfo.GetString("permanent");
		assembly  = serInfo.AssemblyName;

		foreach(string eachAttrib in assembly.Split(new char[] {','}))
		{
			assemblyAttributes = eachAttrib.Split(new char[] {'='});

			if (assemblyAttributes[0].Trim().Equals("Version"))
			{
				Console.WriteLine("Version: {0}", assemblyAttributes[1].Trim());
			}
		}

	}

	public void GetObjectData(SerializationInfo serInfo, StreamingContext streamContext)
	{
		Console.WriteLine("Inside GetObjectData\n");

		serInfo.AddValue("permanent", permanent);
	}

	public string Perm
	{
		get
		{
			return permanent;
		}
		set
		{
			permanent = value;
		}
	}

	public string Temp
	{
		get
		{
			return temporary;
		}
		set
		{
			temporary = value;
		}
	}
}

class CustomSerializer
{
	static void Main(string[] args)
	{
		string fileName = @"Custom.ser";

		Serialized serOut = new Serialized();

		serOut.Perm = "I'm persistent.";
		serOut.Temp = "I'm transient.";

		Console.WriteLine("Before Serialization:\n");
		Console.WriteLine("\tPerm: '{0}'\n\tTemp: '{1}'\n", serOut.Perm, serOut.Temp);

		FileStream outStream = new FileStream(fileName, FileMode.OpenOrCreate, FileAccess.Write);

		SoapFormatter soapWriter = new SoapFormatter();
		soapWriter.Serialize(outStream, serOut);

		outStream.Close();

		FileStream inStream = new FileStream(fileName, FileMode.Open, FileAccess.Read);

		StreamReader sReader = new StreamReader(inStream);
		string serializedFile = sReader.ReadToEnd();

		Console.WriteLine("Contents of Serialized File: \n");
		Console.WriteLine("{0}\n", serializedFile);

		inStream.Seek(0, SeekOrigin.Begin);

		Serialized serIn = new Serialized();

		SoapFormatter soapReader = new SoapFormatter();
		serIn = (Serialized) soapReader.Deserialize(inStream);

		Console.WriteLine("After Serialization:\n");
		Console.WriteLine("\tPerm: '{0}'\n\tTemp: '{1}'\n", serIn.Perm, serIn.Temp);

		inStream.Close();

		Console.ReadLine();
	}
}
