using System;
using System.IO;

public class FileWatch
{
	public FileWatch()
	{
		FileSystemWatcher fileWatch = new FileSystemWatcher(".", "*.*");

		fileWatch.Renamed += new RenamedEventHandler(this.HandleRenamedFile);
		fileWatch.EnableRaisingEvents = true;
	}

	public void HandleRenamedFile(object sender, RenamedEventArgs e)
	{
		Console.WriteLine("\nFile Renamed:\n");

		Console.WriteLine("Change Type:   {0}", e.ChangeType );
		Console.WriteLine("Full Path:     {0}", e.FullPath   );
		Console.WriteLine("Name:          {0}", e.Name       );
		Console.WriteLine("Old Full Path: {0}", e.OldFullPath);
		Console.WriteLine("Old Name:      {0}", e.OldName    );
	}

	static void Main(string[] args)
	{
		FileWatch fw = new FileWatch();

		// sit and wait for file changes
		Console.ReadLine();
	}
}
