using System;
using System.IO;

class ModDirs
{
	DirectoryInfo myDir;

	public ModDirs()
	{
		myDir = new DirectoryInfo(
			@"D:\My Documents"         +
			@"\Visual Studio Projects" +
			@"\Chapter 17\Listing17.2" );
	}

	public void ShowDirInfo()
	{
		string        name     = myDir.Name;
		string        fullName = myDir.FullName;
		DirectoryInfo parent   = myDir.Parent;
		DirectoryInfo root     = myDir.Root;

		Console.WriteLine("\nDirectory Info:");
		Console.WriteLine(  "---------------\n");

		Console.WriteLine("Name:      {0}", name     );
		Console.WriteLine("Full Name: {0}", fullName );
		Console.WriteLine("Parent:    {0}", parent   );
		Console.WriteLine("Root:      {0}", root     );
	}

	public void PrintDirectories(string title)
	{
		Console.WriteLine("\n{0}:", title);

		for (int i=0; i < title.Length; i++)
			Console.Write("-");

		Console.WriteLine();

		DirectoryInfo[] aDirInfo = myDir.GetDirectories();

		foreach (DirectoryInfo eachDir in aDirInfo)
		{
			Console.WriteLine(eachDir.Name);
		}
	}

	static void Main(string[] args)
	{
		string mySubDir = "MySubDirectory";
		string movedDir = "MovedSubDirectory";

		ModDirs md      = new ModDirs();

		md.ShowDirInfo();

		md.PrintDirectories("Directories");

		md.myDir.CreateSubdirectory(mySubDir);

		md.PrintDirectories("After Creating " + mySubDir);

		string srcDir = md.myDir.FullName + @"\" + mySubDir;
		string dstDir = md.myDir.FullName + @"\" + movedDir;

		Directory.Move(srcDir, dstDir);

		md.PrintDirectories("After Moving" + mySubDir + " to " + movedDir);

		Directory.Delete(dstDir);

		md.PrintDirectories("After Deleting " + movedDir);

		Console.ReadLine();
	}
}
