using System;
using System.IO;
using System.Text;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

[Serializable]
public class Serialized
{
	string permanent;

	[NonSerialized]
	string temporary;

	public Serialized()
	{
	}

	public string Perm
	{
		get
		{
			return permanent;
		}
		set
		{
			permanent = value;
		}
	}

	public string Temp
	{
		get
		{
			return temporary;
		}
		set
		{
			temporary = value;
		}
	}
}
	
class Serializer
{


	static void Main(string[] args)
	{
		Serialized serOut = new Serialized();

		serOut.Perm = "I'm persistent.";
		serOut.Temp = "I'm transient.";

		Console.WriteLine("Before Serialization:\n");
		Console.WriteLine("\tPerm: '{0}'\n\tTemp: '{1}'\n", serOut.Perm, serOut.Temp);

		FileStream outStream = new FileStream("Serialized.ser", FileMode.OpenOrCreate, FileAccess.Write);

		BinaryFormatter binWriter = new BinaryFormatter();
		binWriter.Serialize(outStream, serOut);

		outStream.Close();

		FileStream inStream = new FileStream("Serialized.ser", FileMode.Open, FileAccess.Read);

		StreamReader sReader = new StreamReader(inStream);
		string serializedFile = sReader.ReadToEnd();
		Console.WriteLine("Contents of Serialized File: \n");
		Console.WriteLine("\t{0}\n", serializedFile);

		inStream.Seek(0, SeekOrigin.Begin);

		Serialized serIn = new Serialized();

		BinaryFormatter binReader = new BinaryFormatter();
		serIn = (Serialized) binReader.Deserialize(inStream);

		Console.WriteLine("After Serialization:\n");
		Console.WriteLine("\tPerm: '{0}'\n\tTemp: '{1}'\n", serIn.Perm, serIn.Temp);

		inStream.Close();

		Console.ReadLine();
	}
}
