using System;
using System.IO;

class StreamEx
{
	static void Main(string[] args)
	{
		string         fileName  = "test.txt";

		// write file

		FileStream     filStream = new FileStream(fileName, FileMode.OpenOrCreate, FileAccess.Write);
		BufferedStream bufStream = new BufferedStream(filStream);

		StreamWriter sWriter = new StreamWriter(bufStream);

		sWriter.WriteLine("Line Number One");
		sWriter.WriteLine("Line Number Two");

		sWriter.Flush();

		sWriter.Close();

		// read file

		filStream = new FileStream(fileName, FileMode.Open, FileAccess.Read);
		StreamReader sReader = new StreamReader(filStream);

		Console.WriteLine("\nReading File: {0}\n", fileName);

		string line = sReader.ReadLine();

		while (line != null)
		{
			Console.WriteLine(line);
			line = sReader.ReadLine();
		}

		Console.WriteLine("\nSeeking File: {0}\n", fileName);

		filStream.Seek(0, SeekOrigin.Begin);
		Console.WriteLine(sReader.ReadLine());

		char[] buffer = new Char[7];
		filStream.Seek(5, SeekOrigin.Current);
		sReader.Read(buffer, 0, 4);
		Console.WriteLine(new String(buffer));
		Console.WriteLine(sReader.ReadLine());

		filStream.Seek(-12, SeekOrigin.End);
		sReader.Read(buffer, 0, 6);
		Console.WriteLine(new string(buffer));


		sReader.Close();

		Console.ReadLine();
	}
}
