using System;
using System.Xml;
using System.Text;
using System.Collections;

    /// <summary>
    ///    manages a list of money related
    ///    phrases to be obtained by a client
    /// </summary>
    public class MoneyTalk
    {
		ArrayList talk  = new ArrayList();
		string fileName;

        public MoneyTalk(string file)
        {
			fileName = file;
        }

		/// <summary>
		///		write XML data to a file
		/// </summary>
		void WriteXML() 
		{
			XmlTextWriter xr = new XmlTextWriter(fileName, null);

			xr.Formatting = Formatting.Indented;
			xr.Indentation = 4;
			
			xr.WriteStartDocument();
			xr.WriteComment("Holds data for the MoneyTalk program.");
			
			xr.WriteStartElement("MoneyTalk");

			xr.WriteElementString("Talk", "A penny saved is too small, make it a buck.");
			xr.WriteElementString("Talk", "Keep your wooden nickel.  It'll be worth something someday.");
			xr.WriteElementString("Talk", "It's your dime, but you're better off dialing 10-10-XXX.");

			xr.WriteEndElement();

			xr.Flush();
			xr.Close();
		}

		/// <summary>
		///		read XML data from a file
		/// </summary>
		void ReadXML() 
		{
			XmlTextReader xr = new XmlTextReader(fileName);

			string nodeName;

			while (xr.Read())
			{
				nodeName = xr.Name;

				if (nodeName == "Talk")
				{
					talk.Add(xr.ReadString());
				}
			}

			xr = new XmlTextReader(fileName);

			XmlDocument xd = new XmlDocument();

			xd.PreserveWhitespace = true;

			xd.Load(xr);

			Console.WriteLine(xd.InnerXml);

			xr.Close();
		}

		/// <summary>
		///		get a phrase
		/// </summary>
		public string Talk 
		{
			get 
			{
				Random rnd = new Random();

				int index = rnd.Next(talk.Count);

				return (string)talk[index];
			}
		}

        public static int Main(string[] args)
        {
			MoneyTalk mt = new MoneyTalk(@"c:\myxml.xml");

			mt.WriteXML();
			mt.ReadXML();

			Console.WriteLine("\nMoneyTalk: {0}", mt.Talk);

			Console.ReadLine();

            return 0;
        }
    }
