using System;
using System.Data;
using System.Data.OleDb;

	/// <summary>
	///		A program to read database information
	///		and display it on the console screen.
	/// </summary>
class DBAccess
{
	static void Main(string[] args)
	{
		OleDbConnection conn      = null;
		OleDbDataReader dbReader  = null;

		try 
		{
			conn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;User Id=;Password=;Data Source=D:\My Documents\C#\Northwind.mdb");

			conn.Open();

			OleDbCommand cmd = conn.CreateCommand();
			cmd.CommandText  = "SELECT * FROM Shippers";

			dbReader = cmd.ExecuteReader();
			
			for (int i=0; i < dbReader.FieldCount; i++) 
			{
				Console.Write("{0}", dbReader.GetName(i).PadLeft(20, ' '));
			}
			Console.WriteLine("\n{0}", "".PadLeft(60, '-'));

			int    index;
			string companyName;
			string phone;

			while (dbReader.Read())
			{
				index       = dbReader.GetInt32(0);
				companyName = (string)dbReader.GetValue(1);
				phone       = (string)dbReader["Phone"];

				Console.WriteLine("{0}{1}{2}", 
					index.ToString().PadLeft(20, ' '),
					companyName.PadLeft(20, ' '),
					phone.PadLeft(20, ' '));
			}

		}
		catch (OleDbException odbe) 
		{
			Console.WriteLine("OleDbException: {0}", odbe.Message);
		}
		finally 
		{
			if (dbReader != null) 
			{
				dbReader.Close();
				conn.Close();
			}
			Console.ReadLine();
		}
	}
}
