using System;
using System.Data;
using System.Data.OleDb;

	/// <summary>
	///		This class shows how to execute database
	///		commands to manipulate rows in a table.
	/// </summary>
class DataManipulator
{
	// print shippers table to console
	void PrintReport() 
	{
		OleDbDataReader dbReader  = null;
		OleDbConnection conn      = null;

		try 
		{
			conn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;User Id=;Password=;Data Source=D:\My Documents\C#\Northwind.mdb");

			conn.Open();

			OleDbCommand rcmd = conn.CreateCommand();
			rcmd.CommandText  = "SELECT * FROM Shippers";

			dbReader = rcmd.ExecuteReader();

			Console.WriteLine();
			
			for (int i=0; i < dbReader.FieldCount; i++) 
			{
				Console.Write("{0}", dbReader.GetName(i).PadLeft(20, ' '));
			}
			Console.WriteLine("\n{0}", "".PadLeft(60, '-'));

			int    index;
			string companyName;
			string phone;

			while (dbReader.Read())
			{
				index       = dbReader.GetInt32(0);
				companyName = (string)dbReader.GetValue(1);
				phone       = (string)dbReader["Phone"];

				Console.WriteLine("{0}{1}{2}", 
					index.ToString().PadLeft(20, ' '),
					companyName.PadLeft(20, ' '),
					phone.PadLeft(20, ' '));
			}

		}
		catch (OleDbException odbe) 
		{
			Console.WriteLine("OleDbException: {0}", odbe.Message);
		}
		finally 
		{
			if (dbReader != null) 
			{
				dbReader.Close();
				conn.Close();
			}
		}
	}

	// insert, update, or delete row in shippers table
	void ModifyTable(string modCommand)
	{
		OleDbConnection conn      = null;

		try 
		{
			conn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;User Id=;Password=;Data Source=D:\My Documents\C#\Northwind.mdb");

			conn.Open();

			OleDbCommand nqcmd = conn.CreateCommand();
			nqcmd.CommandText  = modCommand;
			nqcmd.ExecuteNonQuery();

		}
		catch (OleDbException odbe) 
		{
			Console.WriteLine("OleDbException: {0}", odbe.Message);
		}
		finally 
		{
			if (conn != null) 
			{
				conn.Close();
			}
		}

	}

	// insert, update, delete, and 
	// print a database table
	static void Main(string[] args)
	{
		DataManipulator dm = new DataManipulator();

		// show original table contents
		dm.PrintReport();
		
		// insert row and show results
		dm.ModifyTable(@"INSERT INTO Shippers 
                         (companyname, phone)
                         VALUES (""Desert Cargo"",
                                 ""480-555-1234"") ");
		dm.PrintReport();

		// modify row and show results
		dm.ModifyTable(@"UPDATE Shippers
                         SET phone = ""(480) 555-1234""
                         WHERE companyname = ""Desert Cargo""
                      ");
		dm.PrintReport();

		// delete row and show results
		dm.ModifyTable(@"DELETE FROM Shippers 
                         WHERE companyname = ""Desert Cargo""
                     ");
		dm.PrintReport();

		Console.ReadLine();
	}
}
