using System;
using System.Data;
using System.Data.SqlClient;

	/// <summary>
	///		Summary description for Class1.
	/// </summary>
class DataSetsExample
{
	static void Main(string[] args)
	{
		SqlConnection conn = null;

		try 
		{

			conn = new SqlConnection("Data Source=localhost;User Id=sa;Password=pwd;Initial Catalog=northwind");

			DataSet shippersDS = new DataSet();
			SqlDataAdapter shippersAdapter = new SqlDataAdapter("SELECT * FROM Shippers", conn);
            
			/*  Database update doesn't work yet
			string insertString = 
				@"
					INSERT INTO Shippers 
                    (companyname, phone)
                    VALUES (@companyName, @phone)
				";

			SqlParameter cmpyName  = shippersAdapter.UpdateCommand.Parameters.Add(new SqlParameter("@companyName", SqlDbType.NVarChar, 20));
			cmpyName.SourceColumn  = "CompanyName";
			cmpyName.Value         = "Desert Cargo";
			//cmpyName.SourceVersion = DataRowVersion.Original;

			SqlParameter phoneNum  = shippersAdapter.UpdateCommand.Parameters.Add(new SqlParameter("@phone", SqlDbType.NVarChar, 20));
			phoneNum.SourceColumn  = "Phone";
			phoneNum.Value         = "(480) 555-1234";
			//phoneNum.SourceVersion = DataRowVersion.Original;

			shippersAdapter.InsertCommand = new SqlCommand(insertString, conn);

			//shippersAdapter.UpdateCommand.Parameters.Add(cmpyName);
			//shippersAdapter.UpdateCommand.Parameters.Add(phoneNum);

			*/

			shippersAdapter.Fill(shippersDS, "Shippers");

			DataTable shippersTable = shippersDS.Tables["Shippers"];

			DataRow newShipper = shippersTable.NewRow();
			newShipper["CompanyName"] = "Desert Cargo";
			newShipper["Phone"]       = "(480) 555-1234";

			shippersTable.Rows.Add(newShipper);

			Console.WriteLine();

			for (int i=1; i < shippersTable.Columns.Count; i++) 
			{
				Console.Write("{0}", shippersTable.Columns[i].Caption.PadLeft(20, ' '));
			}
			Console.WriteLine("\n{0}", "".PadLeft(60, '-'));

			string companyName;
			string phone;

			foreach(DataRow shipper in shippersTable.Rows)
			{
				companyName = (string)shipper["CompanyName"];
				phone       = (string)shipper["Phone"];

				Console.WriteLine("{0}{1}",
					companyName.PadLeft(20, ' '),
					phone.PadLeft(20, ' '));
			}

			//shippersAdapter.Update(shippersDS, "Shippers");
		}
		catch (SqlException sqle) 
		{
			Console.WriteLine("CreateStoredProcedure SqlException: {0}", sqle.Message);
		}
		catch (Exception e) 
		{
			Console.WriteLine("Generic Exception: {0}", e.Message);
		}
		finally 
		{
			if (conn != null) 
			{
				//conn.Close();
			}
			Console.ReadLine();
		}
	}
}
