using System;
using System.IO;
using System.Text;
using System.Net.Sockets;

/// <summary>
///		tcp client
/// </summary>
class EntrepreneurialClient
{
	static void Main(string[] args)
	{
		ASCIIEncoding ASCII = new ASCIIEncoding();
		Byte[] inStream     = new Byte[256];
		Byte[] outStream    = new Byte[256];
		string freeAdvice;
		string choice = "Q";

		do 
		{
			try 
			{
				Console.WriteLine("\nMoney Line\n");
				Console.WriteLine("1 - Get Advice");
				Console.WriteLine("Q - Quit");
				Console.Write("\nPlease Choose:  ");
				choice = Console.ReadLine();
				Console.WriteLine();

				TcpClient myClient  = new TcpClient( "localhost", 2010 );
				Stream myStream     = myClient.GetStream();

				outStream = ASCII.GetBytes("What is the secret of making money?");

				if (choice == "1") 
				{
					// send request to server
					myStream.Write(outStream, 0, outStream.Length);

					// clean garbage chars from byte array
					for (int i=0; i < inStream.Length; i++) 
					{
						inStream[i] = 0;
					}

					// retrieve response from server
					myStream.Read(inStream, 0, inStream.Length);
					freeAdvice = ASCII.GetString(inStream, 0, inStream.Length);

					Console.WriteLine("Server Response: {0}", freeAdvice);
				}
				else 
				{
					// close session with server
					outStream = ASCII.GetBytes("bye");
					myStream.Write(outStream, 0, outStream.Length);
				}
			}
			catch( InvalidOperationException ioe ) 
			{
				Console.WriteLine("Invalid Operation Message: {0}", ioe.Message);
			}
			catch ( Exception e ) 
			{
				Console.WriteLine("Generic Exception Message: {0}", e.Message);
			}

		} while (choice == "1");

	}
}
