using System;
//using System.Globalization;

/// <summary>
///     Custom Attribute Example.
/// </summary>
//[SubTracker()]
[
	Tracker("CR-0001", 
			"some fix", 
			EngineerId = "Joe", 
			ChangeDate = "11/04/2001")
]
class SomeProgram
{
	// code for Listing 27.7
	static void Main(string[] args)
	{
		try 
		{
			Type classType     = typeof(SomeProgram);
			Type attributeType = typeof(TrackerAttribute);

			TrackerAttribute attrib = (TrackerAttribute) 
				Attribute.GetCustomAttribute(classType, attributeType);

			Console.WriteLine("Problem #:    {0}", attrib.ProblemId);
			Console.WriteLine("Engineeer ID: {0}", attrib.EngineerId);
			Console.WriteLine("Change Date:  {0}", attrib.ChangeDate);
			Console.WriteLine("Description:  {0}", attrib.FixDescription);
		}
		catch(Exception e) 
		{
			Console.WriteLine("Generic Exception: {0}\nStack Trace:\n{1}", e.Message, e.StackTrace);
		}

		Console.ReadLine();
	}

/**********************************************
 * code for Listing 26.6 commented out
	static void Main(string[] args)
	{
		SomeProgram sp = new SomeProgram();
	}
***********************************************/
}

[
	AttributeUsage(AttributeTargets.All,
				   AllowMultiple = true,
				   Inherited     = true)
]
public class TrackerAttribute : Attribute
{
	public  string   ProblemId;
	public  string   EngineerId;

	private string   fixDescription;
	private DateTime changeDate;

	public string FixDescription 
	{
		get 
		{
			return fixDescription;
		}
		set 
		{
			fixDescription = value;
		}
	}

	public string ChangeDate
	{
		get 
		{
			return changeDate.ToString("d");
		}
		set 
		{
			changeDate = DateTime.Parse(value);
		}
	}
	
	public TrackerAttribute()
	{
		ProblemId      = "UNASSIGNED";
		EngineerId     = "Unidentified Engineer";
		FixDescription = "No description provided";
		ChangeDate     = "01/01/2001";
	}

	public TrackerAttribute(string problemId, string fixDescription)
	{
		ProblemId      = problemId;
		EngineerId     = "Unidentified Engineer";
		FixDescription = fixDescription;
		ChangeDate     = "01/01/2001";
	}
}

[
AttributeUsage(AttributeTargets.All,
	AllowMultiple = true,
	Inherited     = true)
]
class SubTracker : TrackerAttribute 
{
}
