using System;

	/// <summary>
	///		Pointer Arithmetic Demonstration.
	/// </summary>
class PointerArithmetic
{
	struct IntStruct 
	{
		public int one;
		public int two;
		public int three;

		public IntStruct(int first, int second, int third) 
		{
			one   = first;
			two   = second;
			three = third;
		}
	}

	unsafe static void Main(string[] args)
	{
		PointerArithmetic usc = new PointerArithmetic();
		usc.IntTest();

		IntStruct myIntStruct = new IntStruct(3, 5, 7);

		int *intPtr = (int *)&myIntStruct;

		Console.WriteLine("\nPointer with array indexing - \n");
		for (int i=0; i < 3; i++) 
		{
			Console.WriteLine("intPtr[]: {0}", intPtr[i]);
		}

		Console.WriteLine("\nPointer arithmetic - \n");
		for (int i=0; i < 3; i++) 
		{
			Console.WriteLine("*intPtr: {0}", *intPtr++);
		}

		Console.WriteLine("\nPointer member access - \n");

		IntStruct *isPtr = &myIntStruct;
		Console.WriteLine("isPtr->one:   {0}", isPtr->one);
		Console.WriteLine("isPtr->two:   {0}", isPtr->two);
		Console.WriteLine("isPtr->three: {0}", isPtr->three);

		Console.ReadLine();
	}

	unsafe void IntTest() 
	{
		int *intPtr;

		int myInt = 7;

		intPtr = &myInt;

		int retrievedInt = *intPtr;

		int **intPtrPtr = &intPtr;

		Console.WriteLine("IntTest: {0}", intPtr[0]);
	}
}
