using System;

class WeakestLink
{
	static void Main(string[] args)
	{
		Console.WriteLine("Strong References Created:");

		LinkA la = new LinkA();
		LinkB lb = new LinkB();

		Console.WriteLine("Weak References Created:");

		WeakReference wra = new WeakReference(la, true);
		WeakReference wrb = new WeakReference(lb, true);

		la = null;
		lb = null;

		Console.WriteLine("First Collection:");

		GC.Collect();

		la = (LinkA)wra.Target;
		lb = (LinkB)wrb.Target;

		if (la == null)
			Console.WriteLine("LinkA has been collected.");
		else
			Console.WriteLine("LinkA has been revived.");

		if (lb == null)
			Console.WriteLine("LinkB has been collected.");
		else
			Console.WriteLine("LinkB has been revived.");

		Console.WriteLine("Making LinkB Weak Again:");

		WeakReference wrb2 = new WeakReference(lb);
		GC.ReRegisterForFinalize(lb);
		lb = null;

		Console.WriteLine("Second Collection:");

		GC.Collect();

		Console.WriteLine("Third Collection:");

		GC.Collect();

		lb = (LinkB)wrb.Target;

		if (lb == null)
			Console.WriteLine("LinkB has been collected.");
		else
			Console.WriteLine("LinkB has been revived.");

		Console.ReadLine();
	}
}

class LinkA
{
	public LinkA()
	{
		Console.WriteLine("LinkA initialized.");
	}
}

class LinkB
{
	public LinkB()
	{
		Console.WriteLine("LinkB initialized.");
	}

	~LinkB()
	{
		Console.WriteLine("I am the weakest link, G'dby!");
	}
}
